
Namespace EWindow
	#Include Once  "fbgfx.bi"
	#Include Once "windows.bi"
	Using fb
	
	Dim hWnd As HWND = 0
	Dim OldLong As Long = 0
	Dim Shared WinExists As Boolean = FALSE 
	Dim Shared hThread As HANDLE = 0
	'Ovo je ustvari pokazivac na subrutinu iz drugog fajla . Moze da se redefinise ako trebaju neki parametri
	Dim Shared MsgLoopProc As Sub()  = 0 
	
	'Subklasiramo Window proceduru da bi imali vecu kontrolu nad ponasanjem prozora
	'Ovo je nasa window procedura
	'Stavio sam je iznad zbog adresiranja ... da nemoram da je deklarisem
	Function WndProc(ByVal hWin As HWND,ByVal uMsg As UINT,ByVal wParam As WPARAM,ByVal lParam As LPARAM) As Integer
	Select Case uMsg
		
		Case WM_CLOSE
			DestroyWindow(hWin)
			Return FALSE 
			
		Case WM_DESTROY ' Ovo je poslednja windows MSG ovom prozoru
			PostQuitMessage(0)
			WinExists = FALSE
			Return FALSE 
		
		Case WM_COMMAND
			Return  FALSE 
			
		Case WM_SIZE
			Return  FALSE 
		
		Case Else
			Return DefWindowProc(hWin,uMsg,wParam,lParam)
			
	End Select
	Return TRUE
	End Function
	
	'Ovo je sablon ThreadProc , iz nje samo pozivamo pravu funkciju ... ovde smo vec u posebnom Threadu
	Function ThreadProc(Param As LPVOID) As Dword
	If Not  MsgLoopProc = 0 Then  MsgLoopProc()
	Return 0
	End Function
	
	'Obu subrutinu windows poziva u pravilnim intervalima ... ako smo postavili timer sa ESetTimer
	Sub TimerProc(ByVal hwnd As HWND  ,ByVal uMsg As UINT,ByVal idEvent As UINT,ByVal dwTime As DWORD)
		ScreenControl(POLL_EVENTS) ' Fosiramo GL da ocita window messages
		'Ovde cemo da kreiramo novi Thread u svakom novom intervalu
		'Treba paziti da Kod igre u WorkerSub moze da se izvrsi u jednom intervalu (ovde je podeseno 35ms)
		'jer inace moze da dodje do preplitanja izvrsenja i istovremenog pristupa globalnim promenljivim sto moze da stvori problem
		'Da se ovo ne radi u novom Threadu zakloni sledeci red
		#Define Thraded 
		#Ifdef Thraded
		Dim hTr As HANDLE = 0, ti As Dword = 0
		hTr = CreateThread(NULL,NULL,@ThreadProc,0,NULL,@ti)
		#else
		If Not  MsgLoopProc = 0 Then  MsgLoopProc()
		#EndIf 
	End Sub 
   
	Function ECreateWindow(ByVal X As Integer,ByVal Y As Integer,ByVal BPP As Integer,ByVal pg As Integer,ByVal fl As Integer) As Long
	Screenres X, Y, BPP, pg, fl
	'Ovako dobijamo hWnd posle ScreenRes
	ScreenControl GET_WINDOW_HANDLE , hWnd
	If hWnd = 0 Then Return 0
	'Subklasiramo WinProc i pamtimo adreu stare da bi je posle vratili ... ovo je sistemska stvar
	OldLong = SetWindowLong(hWnd,GWL_WNDPROC,@WndProc)
	Return OldLong
	End Function
	
	'Ovde podesavamo timer interval i subrutinu koju cemo periodicno da pozivamo
	'Namestili smo na TimerProc(zbog windows definicije ... mora taj format sa 4 parametra) ali ustvari preko nje pozivamo onu koju smo ovde podesili
	Function ESetTimer(ByVal TimerInt As Integer,WSub As Long ptr ) As UINT 
		MsgLoopProc = WSub
		If hWnd <> 0 Then SetTimer(hWnd,1,TimerInt,@TimerProc) Else Return 0
		WinExists = TRUE 
		hThread = GetCurrentThread()
		'SuspendThread(hThread) ' Cekamo dok postoji GL Window
		While WinExists 
			Sleep 1
		Wend
	End Function
	
	'Ovde sklanjamo timer i prekidamo krug igre
	Function ERemoveTimer() As Boolean
		Return KillTimer(hWnd,1)
	End Function
	
End Namespace